
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Marketplace_ordersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const marketplace_orders = await db.marketplace_orders.create(
            {
                id: data.id || undefined,
        
        amount: data.amount
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        ordered_at: data.ordered_at
        ||
        null
            ,
            
        fulfilled_at: data.fulfilled_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await marketplace_orders.setListing( data.listing || null, {
            transaction,
        });
        
        await marketplace_orders.setBuyer_user( data.buyer_user || null, {
            transaction,
        });
        
        await marketplace_orders.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return marketplace_orders;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const marketplace_ordersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                amount: item.amount
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                ordered_at: item.ordered_at
            ||
            null
            ,
            
                fulfilled_at: item.fulfilled_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const marketplace_orders = await db.marketplace_orders.bulkCreate(marketplace_ordersData, { transaction });

        // For each item created, replace relation files
        

        return marketplace_orders;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const marketplace_orders = await db.marketplace_orders.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.ordered_at !== undefined) updatePayload.ordered_at = data.ordered_at;
        
        
        if (data.fulfilled_at !== undefined) updatePayload.fulfilled_at = data.fulfilled_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await marketplace_orders.update(updatePayload, {transaction});

        
        
        if (data.listing !== undefined) {
            await marketplace_orders.setListing(
              
              data.listing,
              
              { transaction }
            );
        }
        
        if (data.buyer_user !== undefined) {
            await marketplace_orders.setBuyer_user(
              
              data.buyer_user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await marketplace_orders.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return marketplace_orders;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const marketplace_orders = await db.marketplace_orders.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of marketplace_orders) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of marketplace_orders) {
                await record.destroy({transaction});
            }
        });


        return marketplace_orders;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const marketplace_orders = await db.marketplace_orders.findByPk(id, options);

        await marketplace_orders.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await marketplace_orders.destroy({
            transaction
        });

        return marketplace_orders;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const marketplace_orders = await db.marketplace_orders.findOne(
            { where },
            { transaction },
        );

        if (!marketplace_orders) {
            return marketplace_orders;
        }

        const output = marketplace_orders.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.listing = await marketplace_orders.getListing({
            transaction
        });
        
        
        output.buyer_user = await marketplace_orders.getBuyer_user({
            transaction
        });
        
        
        output.organizations = await marketplace_orders.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.marketplace_listings,
        as: 'listing',
        
        where: filter.listing ? {
          [Op.or]: [
            { id: { [Op.in]: filter.listing.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.listing.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'buyer_user',
        
        where: filter.buyer_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.buyer_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.buyer_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.ordered_atRange) {
                const [start, end] = filter.ordered_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    ordered_at: {
                    ...where.ordered_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    ordered_at: {
                    ...where.ordered_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.fulfilled_atRange) {
                const [start, end] = filter.fulfilled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    fulfilled_at: {
                    ...where.fulfilled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    fulfilled_at: {
                    ...where.fulfilled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.currency) {
                where = {
                    ...where,
                currency: filter.currency,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.marketplace_orders.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'marketplace_orders',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.marketplace_orders.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

